import type { _DOMAbstractView } from "./DOMAbstractView.js";
import type { _DOMAttr } from "./DOMAttr.js";
import type { _DOMCDATASection } from "./DOMCDATASection.js";
import type { _DOMCSSRuleList } from "./DOMCSSRuleList.js";
import type { _DOMCSSStyleDeclaration } from "./DOMCSSStyleDeclaration.js";
import type { _DOMComment } from "./DOMComment.js";
import type { _DOMDocumentFragment } from "./DOMDocumentFragment.js";
import type { _DOMDocumentType } from "./DOMDocumentType.js";
import type { _DOMElement } from "./DOMElement.js";
import type { _DOMEntityReference } from "./DOMEntityReference.js";
import type { _DOMEvent } from "./DOMEvent.js";
import type { _DOMHTMLCollection } from "./DOMHTMLCollection.js";
import type { _DOMHTMLElement } from "./DOMHTMLElement.js";
import type { _DOMImplementation } from "./DOMImplementation.js";
import type { _DOMNode } from "./DOMNode.js";
import type { _DOMNodeFilter } from "./DOMNodeFilter.js";
import type { _DOMNodeIterator } from "./DOMNodeIterator.js";
import type { _DOMNodeList } from "./DOMNodeList.js";
import type { _DOMProcessingInstruction } from "./DOMProcessingInstruction.js";
import type { _DOMRange } from "./DOMRange.js";
import type { _DOMStyleSheetList } from "./DOMStyleSheetList.js";
import type { _DOMText } from "./DOMText.js";
import type { _DOMTreeWalker } from "./DOMTreeWalker.js";
import type { _DOMXPathExpression } from "./DOMXPathExpression.js";
import type { _DOMXPathNSResolver } from "./DOMXPathNSResolver.js";
import type { _DOMXPathResult } from "./DOMXPathResult.js";
import type { _WebFrame } from "./WebFrame.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _NSURL } from "../Foundation/NSURL.js";
export declare class _DOMDocument extends _DOMNode {
    static alloc(): _DOMDocument;
    static new(): _DOMDocument;
    init(): _DOMDocument;
    createElement$(tagName: _NSString): _DOMElement;
    createDocumentFragment(): _DOMDocumentFragment;
    createTextNode$(data: _NSString): _DOMText;
    createComment$(data: _NSString): _DOMComment;
    createCDATASection$(data: _NSString): _DOMCDATASection;
    createProcessingInstruction$data$(target: _NSString, data: _NSString): _DOMProcessingInstruction;
    createAttribute$(name: _NSString): _DOMAttr;
    createEntityReference$(name: _NSString): _DOMEntityReference;
    getElementsByTagName$(tagname: _NSString): _DOMNodeList;
    importNode$deep$(importedNode: _DOMNode, deep: boolean): _DOMNode;
    createElementNS$qualifiedName$(namespaceURI: _NSString, qualifiedName: _NSString): _DOMElement;
    createAttributeNS$qualifiedName$(namespaceURI: _NSString, qualifiedName: _NSString): _DOMAttr;
    getElementsByTagNameNS$localName$(namespaceURI: _NSString, localName: _NSString): _DOMNodeList;
    adoptNode$(source: _DOMNode): _DOMNode;
    createEvent$(eventType: _NSString): _DOMEvent;
    createRange(): _DOMRange;
    createNodeIterator$whatToShow$filter$expandEntityReferences$(root: _DOMNode, whatToShow: number, filter: _DOMNodeFilter, expandEntityReferences: boolean): _DOMNodeIterator;
    createTreeWalker$whatToShow$filter$expandEntityReferences$(root: _DOMNode, whatToShow: number, filter: _DOMNodeFilter, expandEntityReferences: boolean): _DOMTreeWalker;
    getOverrideStyle$pseudoElement$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSStyleDeclaration;
    createExpression$resolver$(expression: _NSString, resolver: _DOMXPathNSResolver): _DOMXPathExpression;
    createNSResolver$(nodeResolver: _DOMNode): _DOMXPathNSResolver;
    evaluate$contextNode$resolver$type$inResult$(expression: _NSString, contextNode: _DOMNode, resolver: _DOMXPathNSResolver, type: number, inResult: _DOMXPathResult): _DOMXPathResult;
    execCommand$userInterface$value$(command: _NSString, userInterface: boolean, value: _NSString): boolean;
    execCommand$userInterface$(command: _NSString, userInterface: boolean): boolean;
    execCommand$(command: _NSString): boolean;
    queryCommandEnabled$(command: _NSString): boolean;
    queryCommandIndeterm$(command: _NSString): boolean;
    queryCommandState$(command: _NSString): boolean;
    queryCommandSupported$(command: _NSString): boolean;
    queryCommandValue$(command: _NSString): _NSString;
    getElementsByName$(elementName: _NSString): _DOMNodeList;
    elementFromPoint$y$(x: number, y: number): _DOMElement;
    createCSSStyleDeclaration(): _DOMCSSStyleDeclaration;
    getComputedStyle$pseudoElement$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSStyleDeclaration;
    getMatchedCSSRules$pseudoElement$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSRuleList;
    getMatchedCSSRules$pseudoElement$authorOnly$(element: _DOMElement, pseudoElement: _NSString, authorOnly: boolean): _DOMCSSRuleList;
    getElementsByClassName$(classNames: _NSString): _DOMNodeList;
    hasFocus(): boolean;
    webkitCancelFullScreen(): void;
    getElementById$(elementId: _NSString): _DOMElement;
    querySelector$(selectors: _NSString): _DOMElement;
    querySelectorAll$(selectors: _NSString): _DOMNodeList;
    createProcessingInstruction$$(target: _NSString, data: _NSString): _DOMProcessingInstruction;
    importNode$$(importedNode: _DOMNode, deep: boolean): _DOMNode;
    createElementNS$$(namespaceURI: _NSString, qualifiedName: _NSString): _DOMElement;
    createAttributeNS$$(namespaceURI: _NSString, qualifiedName: _NSString): _DOMAttr;
    getElementsByTagNameNS$$(namespaceURI: _NSString, localName: _NSString): _DOMNodeList;
    createNodeIterator$$$$(root: _DOMNode, whatToShow: number, filter: _DOMNodeFilter, expandEntityReferences: boolean): _DOMNodeIterator;
    createTreeWalker$$$$(root: _DOMNode, whatToShow: number, filter: _DOMNodeFilter, expandEntityReferences: boolean): _DOMTreeWalker;
    getOverrideStyle$$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSStyleDeclaration;
    createExpression$$(expression: _NSString, resolver: _DOMXPathNSResolver): _DOMXPathExpression;
    evaluate$$$$$(expression: _NSString, contextNode: _DOMNode, resolver: _DOMXPathNSResolver, type: number, inResult: _DOMXPathResult): _DOMXPathResult;
    getComputedStyle$$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSStyleDeclaration;
    /**
     * Constructs a URL given an attribute string. This method constructs a URL given an attribute string just as WebKit does. An attribute string is the value of an attribute of an element such as the href attribute on the DOMHTMLAnchorElement class. This method is only applicable to attributes that refer to URLs.
     */
    URLWithAttributeString$(string_: _NSString): _NSURL;
    doctype(): _DOMDocumentType;
    implementation(): _DOMImplementation;
    documentElement(): _DOMElement;
    inputEncoding(): _NSString;
    xmlEncoding(): _NSString;
    xmlVersion(): _NSString;
    setXmlVersion$(value: _NSString): void;
    xmlStandalone(): boolean;
    setXmlStandalone$(value: boolean): void;
    documentURI(): _NSString;
    setDocumentURI$(value: _NSString): void;
    defaultView(): _DOMAbstractView;
    styleSheets(): _DOMStyleSheetList;
    title(): _NSString;
    setTitle$(value: _NSString): void;
    referrer(): _NSString;
    domain(): _NSString;
    URL(): _NSString;
    cookie(): _NSString;
    setCookie$(value: _NSString): void;
    body(): _DOMHTMLElement;
    setBody$(value: _DOMHTMLElement): void;
    images(): _DOMHTMLCollection;
    applets(): _DOMHTMLCollection;
    links(): _DOMHTMLCollection;
    forms(): _DOMHTMLCollection;
    anchors(): _DOMHTMLCollection;
    lastModified(): _NSString;
    charset(): _NSString;
    setCharset$(value: _NSString): void;
    defaultCharset(): _NSString;
    readyState(): _NSString;
    characterSet(): _NSString;
    preferredStylesheetSet(): _NSString;
    selectedStylesheetSet(): _NSString;
    setSelectedStylesheetSet$(value: _NSString): void;
    activeElement(): _DOMElement;
    /** The frame of the DOM document. */
    webFrame(): _WebFrame;
}
